//
// Created by ll on 7/18/24.
//

#include "execution_defs.h"
#include "execution_manager.h"
#include "executor_abstract.h"
#include "index/ix.h"
#include "system/sm.h"

class SubQueryScanExecutor : public AbstractExecutor{
private:
    //std::vector<std::unique_ptr<AbstractExecutor>> prevs_;
    std::unique_ptr<AbstractExecutor> prev_;
//    std::unordered_set<Value> values;
//
//    std::vector<std::unique_ptr<RmRecord>> all_tuples;
    std::vector<std::unique_ptr<RmRecord>> subqueryResults;
    std::vector<ColMeta> cols_;                     //子查询的字段
    Value sub_value_;
    bool is_first;
    int current_idx;
    int len_;

public:
    SubQueryScanExecutor(std::unique_ptr<AbstractExecutor> prev) {
        prev_ = std::move(prev);
        //is_const = false;
        is_first = true;
        current_idx = 0;
        cols_ = prev_->cols();//这里仅仅支持一个子查询
        len_ = cols_[0].len;//仅仅返回一个列的值
        //sub_value_.is_set = true;//先全部放入集合中
        //得到subValue
        beginTuple();
        //this->run();
    }

    std::string getType() override {
        return "SubQueryScan";
    }

    void run(){
        if(!is_first)return;
        for (prev_->beginTuple(); !prev_->is_end(); prev_->nextTuple()) {
            auto rec = prev_->Next();
            auto value = get_value(rec,cols_[0]);//需要确保返回的只有一列
            sub_value_.add_to_set(value);
        }
        is_first = false;
    }
    void beginTuple() override {
        current_idx = 0;
        if(!is_first)return;

        for (prev_->beginTuple(); !prev_->is_end(); prev_->nextTuple()) {
            subqueryResults.push_back(prev_->Next());
        }
        is_first = false;

    }

    void nextTuple() override {
        current_idx++;
        return;
    }

    bool is_end() const override {
        return current_idx == subqueryResults.size();
        return false;
    }

    Rid &rid() override {
        assert(0);
    }

    const std::vector<ColMeta> &cols() const override {
        return prev_->cols();
    }

    std::unique_ptr<RmRecord> Next() override {
        //RmRecord tmp = *subqueryResults[current_idx];
        return std::move(subqueryResults[current_idx]);
    }

    size_t tupleLen() const override {
        return this->len_;
    }

    Value get_sub_value(){
        return sub_value_;
    }
};
